## ros-rolling-avt-vimba-camera 2001.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(avt_vimba_camera)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_auto REQUIRED)

ament_auto_find_build_dependencies()

# Get architecture
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(TargetArchitecture)
target_architecture(ARCH)

###########
## Build ##
###########

include_directories(
  include
)

function(add_dependencies_and_linkings arg)
  if("${ARCH}" STREQUAL x86_64)
    target_link_libraries(${arg}
      ${CMAKE_CURRENT_SOURCE_DIR}/lib/64bit/libVimbaC.so
      ${CMAKE_CURRENT_SOURCE_DIR}/lib/64bit/libVimbaCPP.so
    )
  elseif("${ARCH}" STREQUAL armv7)
    target_link_libraries(${arg}
      ${CMAKE_CURRENT_SOURCE_DIR}/lib/arm_32bit/libVimbaC.so
      ${CMAKE_CURRENT_SOURCE_DIR}/lib/arm_32bit/libVimbaCPP.so
    )
  elseif("${ARCH}" STREQUAL armv8)
    target_link_libraries(${arg}
      ${CMAKE_CURRENT_SOURCE_DIR}/lib/arm_64bit/libVimbaC.so
      ${CMAKE_CURRENT_SOURCE_DIR}/lib/arm_64bit/libVimbaCPP.so
    )
  else()
    message(FATAL_ERROR "[libvimba]: Architecture ${ARCH} not suported. Exiting...")
  endif()
endfunction(add_dependencies_and_linkings)

# Nodes
ament_auto_add_library(mono_camera_node SHARED
  src/mono_camera_node.cpp
  src/avt_vimba_camera.cpp
  src/frame_observer.cpp
)
add_dependencies_and_linkings(mono_camera_node)

ament_auto_add_library(trigger_node SHARED
  src/trigger_node.cpp
)
add_dependencies_and_linkings(trigger_node)

# Executables
ament_auto_add_executable(mono_camera_exec
  src/exec/mono_camera_exec.cpp
)

ament_auto_add_executable(trigger_exec
  src/exec/trigger_exec.cpp
)

#############
## Install ##
#############

if("${ARCH}" STREQUAL x86_64)
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/64bit/libVimbaC.so
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/64bit/libVimbaCPP.so
    DESTINATION lib
  )
elseif("${ARCH}" STREQUAL armv7)
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/arm_32bit/libVimbaC.so
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/arm_32bit/libVimbaCPP.so
    DESTINATION lib
  )
elseif("${ARCH}" STREQUAL armv8)
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/arm_64bit/libVimbaC.so
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/arm_64bit/libVimbaCPP.so
    DESTINATION lib
  )
endif()

install(FILES README.md
  DESTINATION share/${PROJECT_NAME}/
)

ament_auto_package(INSTALL_TO_SHARE
  calibrations
  config
  launch
)

=== debian/changelog ===
ros-rolling-avt-vimba-camera (2001.1.0-4jammy) jammy; urgency=high

  * Port to ROS2 (#56 <https://github.com/astuff/avt_vimba_camera/issues/56>)
  * Update README for ROS2 (#58 <https://github.com/astuff/avt_vimba_camera/issues/58>)
  * Contributors: icolwell-as

 -- AutonomouStuff Software Team <software@autonomoustuff.com>  Fri, 10 Dec 2021 08:00:00 -0000

ros-rolling-avt-vimba-camera (1.0.0-4jammy) jammy; urgency=high

  * Code Cleanup and Autoformat (#52 <https://github.com/astuff/avt_vimba_camera/issues/52>)
  * Improve rosout logging (#50 <https://github.com/astuff/avt_vimba_camera/issues/50>)
  * Improve README (#48 <https://github.com/astuff/avt_vimba_camera/issues/48>)
  * Parameter Refactor (#46 <https://github.com/astuff/avt_vimba_camera/issues/46>)
  * Use timestamp from image capture in ROS header (#41 <https://github.com/astuff/avt_vimba_camera/issues/41>)
  * Trigger over Ethernet (#39 <https://github.com/astuff/avt_vimba_camera/issues/39>)
  * Remove stereo camera code (#43 <https://github.com/astuff/avt_vimba_camera/issues/43>)
  * Update CI (#44 <https://github.com/astuff/avt_vimba_camera/issues/44>)
  * Update to VimbaCPP Version 1.8.4 (SDK version 5.0) (#36 <https://github.com/astuff/avt_vimba_camera/issues/36>)
  * Fixed 'escalating to SIGTERM' when closing (#22 <https://github.com/astuff/avt_vimba_camera/issues/22>)
  * Contributors: icolwell-as, vbrebion

 -- AutonomouStuff Software Team <software@autonomoustuff.com>  Tue, 30 Nov 2021 08:00:00 -0000

ros-rolling-avt-vimba-camera (0.0.12-4jammy) jammy; urgency=high

  * Fix MonoCamera nodelet (#16 <https://github.com/astuff/avt_vimba_camera/issues/16>)
  * Launch File Updates (#13 <https://github.com/astuff/avt_vimba_camera/issues/13>)
  * Remove duplicated launch file installs (#15 <https://github.com/astuff/avt_vimba_camera/issues/15>)
  * Brief README (#10 <https://github.com/astuff/avt_vimba_camera/issues/10>)
  * Add more pixelformats, thanks to @jmoreau-hds (#3 <https://github.com/astuff/avt_vimba_camera/issues/3>)
  * Contributors: icolwell-as

 -- AutonomouStuff Software Team <software@autonomoustuff.com>  Fri, 05 Jun 2020 07:00:00 -0000

ros-rolling-avt-vimba-camera (0.0.11-4jammy) jammy; urgency=high

  * Merge pull request #35 <https://github.com/astuff/avt_vimba_camera/issues/35> from willcbaker/feature/nodelet
    Feature/nodelet
  * Update nodelet launch files
  * Add nodelet
  * Fix #31 <https://github.com/astuff/avt_vimba_camera/issues/31>
  * Merge pull request #30 <https://github.com/astuff/avt_vimba_camera/issues/30> from chewwt/armv8
    add support for armv8
  * add support for armv8
  * Change frame observer to shared ptr
  * Contributors: Miquel Massot, Will Baker, ruth

 -- AutonomouStuff Software Team <software@autonomoustuff.com>  Mon, 19 Aug 2019 07:00:00 -0000

ros-rolling-avt-vimba-camera (0.0.10-4jammy) jammy; urgency=high

  * Merge pull request #26 <https://github.com/srv/avt_vimba_camera/issues/26> from 130s/k/add_ci
    [CI] Add config for ROS Kinetic (and Lunar as an option).
  * [CI] Add config for ROS Kinetic (and Lunar as an option).
  * Merge pull request #25 <https://github.com/srv/avt_vimba_camera/issues/25> from mintar/fix_open_camera
    Fix opening the camera
  * Simplify openCamera() logic
  * Open camera on init
    Without this patch, the camera is never opened. This bug was introduced in 63f868791.
  * Give more information to the user
  * Merge pull request #22 <https://github.com/srv/avt_vimba_camera/issues/22> from plusone-robotics/dyn_reconfig_fix
    Dynamic reconfigure fix
  * Fix #21 <https://github.com/srv/avt_vimba_camera/issues/21>: Retry camera opening and handle SIGINT
  * Changed file mode in order to build
  * Fixed crashing of dynamic reconfigure
  * Fixed dynamic reconfigure configuration that did not allow camera parameters to be updated
  * Fix call QueueFrame() method
  * Fix CPU overhead issue
  * Fix #18 <https://github.com/srv/avt_vimba_camera/issues/18>
  * Merge pull request #17 <https://github.com/srv/avt_vimba_camera/issues/17> from josepqp/kinetic
    Added ARM 32 to CMakeList.txt
  * Stop camera before destroy it
  * Added ARM 32
  * Merge branch 'kinetic' of github.com:srv/avt_vimba_camera into kinetic
  * Change variable scope
  * Fix #15 <https://github.com/srv/avt_vimba_camera/issues/15>: do not depend on turbot_configurations
  * Merge pull request #14 <https://github.com/srv/avt_vimba_camera/issues/14> from josepqp/kinetic
    
      * Added ARM 32 bits libraries
      * Modified CMakeList.txt to compile with ARM 32 bits
      * Added Iris Parameter
    
  * kinetization
  * Fix sync problems after camera tests
  * Add a sync timer
  * Try stereo image sync
  * Add a check timer
  * Fix #12 <https://github.com/srv/avt_vimba_camera/issues/12>: allow bigger resolutions
  * Fix camera info
  * Fix camera config
  * Fix camera info when decimation
  * Make sync node acts as stereo sync checker
  * Include a check timer on stereo_camera
  * Perform the stereo_sync in a separate node
  * Publish camera temperatures
  * Change the way of reset
  * Increase the initial wait time before checking sync
  * Add a sync watcher node
  * Fix branch mix
  * Remove unused variables
  * Left and right callback in a separate thread
  * Change default sync time
  * change logging messages
  * fix binning
  * add stereo launchfiles
  * removed prints
  * set stereo launchfiles
  * removed unused params
  * calibration epi. 4
  * improvements to stereo node
  * merge with v2.0 SDK
  * upgrade to VIMBA SDK 2.0
  * upgrade to 1.4
  * changed ros prints from info to debug
  * removed comment
  * changed stereo camera launchfile
  * Merge pull request #11 <https://github.com/srv/avt_vimba_camera/issues/11> from lucasb-eyer/indigo
    Set the frame_id of the image header, too.
  * Set the frame_id of the image header, too.


=== debian/control ===
Source: ros-rolling-avt-vimba-camera
Section: misc
Priority: optional
Maintainer: AutonomouStuff Software Team <software@autonomoustuff.com>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake-auto, ros-rolling-camera-info-manager, ros-rolling-diagnostic-msgs, ros-rolling-diagnostic-updater, ros-rolling-image-transport, ros-rolling-message-filters, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-ros-workspace
Homepage: https://github.com/astuff/avt_vimba_camera
Standards-Version: 3.9.2

Package: ros-rolling-avt-vimba-camera
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-camera-info-manager, ros-rolling-diagnostic-msgs, ros-rolling-diagnostic-updater, ros-rolling-image-proc, ros-rolling-image-transport, ros-rolling-message-filters, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-stereo-image-proc, ros-rolling-ros-workspace
Description: Camera driver for Allied Vision Technologies (AVT) cameras, based on their Vimba SDK.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-avt-vimba-camera//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install
